| Visioscan Set SDK Libraries 1.3.5 Visioscan Set SDK Help documentation file for C++ and C++/CLI |

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes | List of all members
abstract Class Referenceabstract

Basic abstract communication class. Must be implemented by subclasses in charge of communication. More...

`#include <BaseCommunication.h>`

## Public Member Functions
| BaseCommunication ()
| Base constructor.
| BaseCommunication (MONITORING_MODE monitor)
| Base constructor.
| ~BaseCommunication ()
| Destructor.
void | SetSettings (BaseSettings *settings)
| Sets the communication settings.
BaseSettings * | GetSettings ()
| Gets the communication settings.
void | SetDataExtractor (BaseDataExtractor *pDataExtractor)
| Sets the data extractor.
BaseDataExtractor * | GetDataExtractor ()
| Gets the data extractir.
virtual CommunicationStatus | Connect ()=0
| Pure virtual method that will help the caller to proceed to the connection to media.
virtual void | Disconnect ()=0
| Pure virtual method that will help the caller to proceed to media disconection.
virtual CommunicationStatus | GetConnectionStatus ()=0
| Returns the actual connection state.
bool | IsConnected ()
| Indicates rather or not connect or disconnect method has been called.
virtual string | SendCommand (string commandToSend)=0
| Pure virtual method that will help the caller to send command on the media.
virtual string | SendCommand (string commandToSend, int specificTimeout)=0
| Pure virtual method that will help the caller to send command on the media with a specific timeout.
virtual RawData | WaitForRawData (int waitTimeout, unsigned long *semStatus)=0
| Pure virtual method that will help the caller to wait for RAW data comming from the media.
void | StartMonitoring ()
| Starts the monitoring process.
void | StopMonitoring ()
| Stops the monitoring process.
void | SetCommunicationCallback (ConnectionCheckerCallback)
void | SetCommunicationCallback (void(*ConnectionCheckerCallbackMethod)(CommunicationStatus *))
virtual RawData | ExtractData (vector< string >pDataToExtract)=0
| Pure virtual method that will help the caller to extract the rawdata from a stream.
virtual bool | IsCommandAcknowledgment (string pDataToVerify)=0
| Pure virtual method that will help the caller to discriminate rawdata header from acknowledgment command data.
virtual bool | IsHeader (string pDataToVerify)=0
| Pure virtual method that will thel the caller to check if the packet is a BEA Header.
virtual bool | IsEndOfPacket (string pDataToVerify)=0
| Pure virtual method that will help the caller to check if stream packet is the end of stream.
virtual bool | IsFirstPacket (string pDataToVerify)=0
virtual int | GetPacketHeaderSizeToRead ()=0
| Returns a pointer on an array with a determined size.
virtual int | CountToReadForLength (char *pHeaderBuffer)=0
| Indicates how much byte must be read in order to obtain packet len.
virtual int | GetPacketLengthToRead (char *pLenHeaderBuffer, int pPacketType)=0
| Retrieve, in the pLenHeaderBuffer, the amount of data to read.
| BaseDataRecorder ()
| Base constructor.
| ~BaseDataRecorder ()
| Destructor.
virtual int | GetStatus ()=0
| Returns the recorder's status (STOPPED, PLAYING, RECORDING)
virtual void | Play ()=0
| Plays a record from the file.
virtual void | Pause ()=0
| Pause the playback.
virtual void | Stop ()=0
| Stops either playing or recording.
virtual void | Record ()=0
| Start recording data.
virtual void | ExportToCsv (string pPathToExport, MEASURMENT_UNIT pMeasurmentSystem)=0
| Exports record file to CSV only if recorder is in STOP mode.
virtual void | FetchRecord (RawData data)=0
| Records RawData in the file (internal usage only)
virtual RawData | WaitForRawData ()=0
| Wait for a data comming from the player.
void | SetFrameRate (int pFrameRate)
| Sets the framerate (thread safe)
int | GetFrameRate ()
| Gets the current framerate (thread safe)
long | GetTotalFrame ()
| Returns the total frames contained in the record.
long | GetCurrentFramePosition ()
| Returns the actual frame position in the record whilm being played.
| BaseSensor ()
| Base constructor.
| BaseSensor (BaseCommunication *comm)
| Copy constructor (sets the communication layer)
| ~BaseSensor ()
| Destructor.
BaseCommunication * | GetCommunication ()
| Returns the communication layer.
void | SetCommunication (BaseCommunication *pCom)
| Sets the communication layer.
BaseDataRecorder * | GetDataRecorder ()
| Returns the data recorder.
void | SetDataRecorder (BaseDataRecorder *pDataRecorder)
| Sets the data recorder.
virtual CommunicationStatus | Initialize ()=0
| Pure virtual definition of a function that will initialise the extend class (connection, threads creation etc.)
virtual void | Close ()=0
| Pure virtual method that closes all communication stops all threads and cleanup memory This method must be called when finishing usage of sensor.
virtual RawData | RetrieveRawData ()=0
| Pure virtual definition of a function that will help the caller to retrieve the data.
virtual uint16_t | GetPlatformVersion ()=0
| Gets the platform version /summary> Returns a uint16_t containing the version number
vector< AvailableResolution > | GetAvailableResolutions ()
| Gets available ensor resolutions.
virtual SoftwareVersion | GetVersion ()=0
| Gets the sensor version data.
virtual string | GetDeviceName ()=0
| Gets the sensor's name.
virtual long | GetRuntimeHours ()=0
| Gets the sensor runtime hours.
virtual int | GetTemperature ()=0
| Gets the temperature.
virtual ConfigurationResult | SetDeviceName (string pName)=0
| Sets the sensor's name.
virtual ContaminationStatus | GetContaminationStatus ()=0
| Gets the contamination status.
| BaseSettings ()
| Base constructor.
| ~BaseSettings ()
| Destructor.
int | GetDataTimeout ()
| Gets the data timeouot.
void | SetTranslateCode (string translateCode)
string | GetTranslateCode ()

## Static Public Member Functions
static vector< AvailableResolution > | GetAvailableResolutions (PRODUCT_IDENTIFICATION productIdentifier)

## Static Public Attributes
static const int | STOPPED = 0
static const int | PLAYING = 1
static const int | RECORDING = 2
static const int | FAILED_START_RECORDING = 3
static const int | FAILED_INITIALIZE = 4
static const int | PAUSED = 5

## Protected Member Functions
MONITORING_MODE | GetMonitoringMode ()
| Returns the monitoring mode.
virtual CommunicationStatus | Reconnect ()=0
void | SetTotalFrame (long pTotalFrame)
| Sets the total frame of the record.
void | SetCurrentFramePosition (long pCurrentFramePosition)
| Sets the current frame being read.
MethodCompatibility | GetMethodCompatibility (Method method)
char | ComputeChecksum (string pTocompute)
string | ComputeBinaryCommand (string pToCompute)

## Protected Attributes
std::atomic< bool > | _connected
std::atomic< bool > | _reconnecting
std::atomic< bool > | _isConnected
void * | _mutexMonitoring
void * | _mutexConnectState
| The mutex for the monitoring flag.
volatile int | _connStatus = 0
| The mutex for the connection state value.
string | HEADER = { 0x02 , 0x02, (char)0xBE,(char)0xA0, 0x12, 0x34 }
string | CHECKSUM = { 0x03 }
string | cRN = { 0x63, 0x52, 0x4E }
string | cWN = { 0x63, 0x57, 0x4E }
string | cRA = { 0x63, 0x52, 0x41 }
string | cWA = { 0x63, 0x57, 0x41 }
string | SPC = { 0x20 }
string | SendMDI = { 0x53 ,0x65 ,0x6E ,0x64 ,0x4D ,0x44 ,0x49 }
string | StopMDI = { 0x53 ,0x74 ,0x6F ,0x70 ,0x4D ,0x44 ,0x49 }
string | GetIP = { 0x47, 0x65, 0x74, 0x49, 0x50 }
string | GetGW = { 0x47 ,0x65 ,0x74 ,0x47 ,0x57 }
string | GetMask = { 0x47 ,0x65 ,0x74 ,0x4D ,0x61 ,0x73 ,0x6B }
string | GetDHCP = { 0x47 ,0x65 ,0x74 ,0x44 ,0x48 ,0x43 ,0x50 }
string | GetProto = { 0x47 ,0x65 ,0x74 ,0x50 ,0x72 ,0x6F ,0x74 ,0x6F }
string | GetPort = { 0x47 ,0x65 ,0x74 ,0x50 ,0x6F ,0x72 ,0x74 }
string | GetPType = { 0x47 ,0x65 ,0x74 ,0x50 ,0x54 ,0x79 ,0x70, 0x65 }
string | GetResol = { 0x47 ,0x65 ,0x74 ,0x52 ,0x65 ,0x73 ,0x6F, 0x6C }
string | GetDir = { 0x47 ,0x65 ,0x74 ,0x44 ,0x69 ,0x72 }
string | GetRange = { 0x47 ,0x65 ,0x74 ,0x52, 0x61, 0x6E, 0x67, 0x65 }
string | GetSkip = { 0x47 ,0x65 ,0x74 ,0x53, 0x6B, 0x69, 0x70 }
string | GetCont = { 0x47 ,0x65 ,0x74 ,0x43, 0x6F, 0x6E, 0x74 }
string | GetStat = { 0x47 ,0x65 ,0x74 ,0x53, 0x74, 0x61, 0x74 }
string | GetVer = { 0x47 ,0x65 ,0x74 ,0x56, 0x65, 0x72 }
string | GetPLVerBin = { 0x47, 0x65, 0x74, 0x50, 0x4C, 0x56, 0x65, 0x72 }
string | GetTem = { 0x47 ,0x65 ,0x74 ,0x54, 0x65, 0x6D }
string | GetELog = { 0x47 ,0x65 ,0x74 ,0x45, 0x4C, 0x6F, 0x67 }
string | GetLED = { 0x47 ,0x65 ,0x74 ,0x4C, 0x45, 0x44 }
string | GetLamp = { 0x47 ,0x65 ,0x74 ,0x4C, 0x61, 0x6D, 0x70 }
string | GetEthCfg = { 0x47 ,0x65 ,0x74 ,0x45 ,0x74 ,0x68, 0x43, 0x66, 0x67 }
string | GetHours = { 0x47 ,0x65 ,0x74 ,0x48 ,0x6F ,0x75, 0x72, 0x73 }
string | GetName = { 0x47 ,0x65 ,0x74 ,0x4E ,0x61 ,0x6D, 0x65 }
string | GetFilter = { 0x47 ,0x65 ,0x74 ,0x46 ,0x69 ,0x6C, 0x74, 0x65 , 0x72 }
string | GetWCalib = { 0x47 ,0x65 ,0x74, 0x57, 0x43, 0x61, 0x6C, 0x69, 0x62 }
string | GetWinStat = { 0x47, 0x65, 0x74, 0x57, 0x69, 0x6E, 0x53, 0x74, 0x61, 0x74 }
string | GetECode = { 0x47 ,0x65 ,0x74 ,0x45 ,0x43 ,0x6F, 0x64, 0x65 }
string | SetIP = { 0x53, 0x65, 0x74, 0x49, 0x50 }
string | SetGW = { 0x53, 0x65, 0x74, 0x47, 0x57 }
string | SetMask = { 0x53, 0x65, 0x74, 0x4D, 0x61, 0x73, 0x6B }
string | SetDHCP = { 0x53, 0x65, 0x74, 0x44, 0x48, 0x43, 0x50 }
string | SetProto = { 0x53, 0x65, 0x74, 0x50, 0x72, 0x6F, 0x74,0x6F }
string | SetPort = { 0x53, 0x65, 0x74, 0x50, 0x6F, 0x72, 0x74 }
string | SetPType = { 0x53, 0x65, 0x74, 0x50, 0x54, 0x79, 0x70, 0x65 }
string | SetResol = { 0x53, 0x65, 0x74, 0x52,0x65, 0x73, 0x6F, 0x6C }
string | SetDir = { 0x53, 0x65, 0x74, 0x44, 0x69, 0x72 }
string | SetRange = { 0x53, 0x65, 0x74, 0x52, 0x61, 0x6E, 0x67, 0x65 }
string | SetSkip = { 0x53, 0x65, 0x74, 0x53, 0x6B, 0x69, 0x70 }
string | SetCont = { 0x53, 0x65, 0x74, 0x43, 0x6F, 0x6E, 0x74 }
string | SetLED = { 0x53, 0x65, 0x74, 0x4C, 0x45, 0x44 }
string | SetEthCfg = { 0x53 ,0x65 ,0x74 ,0x45 ,0x74 ,0x68, 0x43, 0x66, 0x67 }
string | SetName = { 0x53 ,0x65 ,0x74 ,0x4E ,0x61 ,0x6D, 0x65 }
string | SetFilter = { 0x53 ,0x65 ,0x74 ,0x46 ,0x69 ,0x6C, 0x74, 0x65 , 0x72 }
string | SetWCalib = { 0x53 ,0x65 ,0x74, 0x57, 0x43, 0x61, 0x6C, 0x69, 0x62 }
string | Reset = { 0x52, 0x65, 0x73, 0x65, 0x74 }
string | Reboot = { 0x52, 0x65, 0x62, 0x6F, 0x6F, 0x74 }
SoftwareVersion | __version
int | _dataTimeout

## Detailed Description

Basic abstract communication class. Must be implemented by subclasses in charge of communication.

Basic abstract communication settings class. Must be implemented by subclasses in charge of communication settings.

Basic representation of a sensor. Must be inherited by subclasses in charge of sensor implementation This base class encapsulate the communication mechanism.

A basic data extractor used by the communication classes to know HOW to extract RAW data from a stream.

## Constructor & Destructor Documentation

## ◆ ~BaseCommunication()

abstract::~BaseCommunication | ( |  | ) |

Destructor.

## ◆ ~BaseDataRecorder()

abstract::~BaseDataRecorder | ( |  | ) |

Destructor.

## ◆ ~BaseSensor()

abstract::~BaseSensor | ( |  | ) |

Destructor.

## ◆ ~BaseSettings()

abstract::~BaseSettings | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ BaseCommunication() [1/2]

abstract::BaseCommunication | ( |  | ) |

Base constructor.

## ◆ BaseCommunication() [2/2]

abstract::BaseCommunication | ( | MONITORING_MODE | monitor | ) |

Base constructor.

## ◆ BaseDataRecorder()

abstract::BaseDataRecorder | ( |  | ) |

Base constructor.

## ◆ BaseSensor() [1/2]

abstract::BaseSensor | ( |  | ) |

Base constructor.

## ◆ BaseSensor() [2/2]

abstract::BaseSensor | ( | BaseCommunication * | comm | ) |

Copy constructor (sets the communication layer)

Parameters

  comm | The communication layer to be used

## ◆ BaseSettings()

abstract::BaseSettings | ( |  | ) |

Base constructor.

## ◆ Close()

virtual void abstract::Close | ( |  | ) |
| pure virtual

Pure virtual method that closes all communication stops all threads and cleanup memory This method must be called when finishing usage of sensor.

## ◆ ComputeBinaryCommand()

string abstract::ComputeBinaryCommand | ( | string | pToCompute | ) |
| protected

## ◆ ComputeChecksum()

char abstract::ComputeChecksum | ( | string | pTocompute | ) |
| protected

## ◆ Connect()

virtual CommunicationStatus abstract::Connect | ( |  | ) |
| pure virtual

Pure virtual method that will help the caller to proceed to the connection to media.

## ◆ CountToReadForLength()

virtual int abstract::CountToReadForLength | ( | char * | pHeaderBuffer | ) |
| pure virtual

Indicates how much byte must be read in order to obtain packet len.

Returns
  An integer representing the amount of bytes to read

## ◆ Disconnect()

virtual void abstract::Disconnect | ( |  | ) |
| pure virtual

Pure virtual method that will help the caller to proceed to media disconection.

## ◆ ExportToCsv()

virtual void abstract::ExportToCsv | ( | string | pPathToExport,
|  | MEASURMENT_UNIT | pMeasurmentSystem )
| pure virtual

Exports record file to CSV only if recorder is in STOP mode.

Parameters

  pPathToExport | The fulle filepath name to export the data

## ◆ ExtractData()

virtual RawData abstract::ExtractData | ( | vector< string > | pDataToExtract | ) |
| pure virtual

Pure virtual method that will help the caller to extract the rawdata from a stream.

Parameters

  pDataToExtract | A vector representing the data frames

Returns
  A Raw Data object

## ◆ FetchRecord()

virtual void abstract::FetchRecord | ( | RawData | data | ) |
| pure virtual

Records RawData in the file (internal usage only)

Parameters

  data | The rawdata to be recorded

## ◆ GetAvailableResolutions() [1/2]

vector< AvailableResolution > abstract::GetAvailableResolutions | ( |  | ) |

Gets available ensor resolutions.

Returns

## ◆ GetAvailableResolutions() [2/2]

static vector< AvailableResolution > abstract::GetAvailableResolutions | ( | PRODUCT_IDENTIFICATION | productIdentifier | ) |
| static

## ◆ GetCommunication()

BaseCommunication * abstract::GetCommunication | ( |  | ) |

Returns the communication layer.

Returns
  A pointer to the basic communication layer encapsulation

## ◆ GetConnectionStatus()

virtual CommunicationStatus abstract::GetConnectionStatus | ( |  | ) |
| pure virtual

Returns the actual connection state.

Returns
  An enumeration with connection status

## ◆ GetContaminationStatus()

virtual ContaminationStatus abstract::GetContaminationStatus | ( |  | ) |
| pure virtual

Gets the contamination status.

Returns
  An ContaminationStatus representing the contamination status

## ◆ GetCurrentFramePosition()

long abstract::GetCurrentFramePosition | ( |  | ) |

Returns the actual frame position in the record whilm being played.

Returns

## ◆ GetDataExtractor()

BaseDataExtractor * abstract::GetDataExtractor | ( |  | ) |

Gets the data extractir.

Returns
  A pointer to the data extractor

## ◆ GetDataRecorder()

BaseDataRecorder * abstract::GetDataRecorder | ( |  | ) |

Returns the data recorder.

Returns
  A pointer to the basic data recorder layer encapsulation

## ◆ GetDataTimeout()

int abstract::GetDataTimeout | ( |  | ) |

Gets the data timeouot.

Returns
  The data timeout represented as an int

## ◆ GetDeviceName()

virtual string abstract::GetDeviceName | ( |  | ) |
| pure virtual

Gets the sensor's name.

Returns
  A string representing the sensor's name

## ◆ GetFrameRate()

int abstract::GetFrameRate | ( |  | ) |

Gets the current framerate (thread safe)

Returns

## ◆ GetMethodCompatibility()

MethodCompatibility abstract::GetMethodCompatibility | ( | Method | method | ) |
| protected

## ◆ GetMonitoringMode()

MONITORING_MODE abstract::GetMonitoringMode | ( |  | ) |
| protected

Returns the monitoring mode.

Returns
  MONITORING_OFF, MONITORING_ON or AUTO_RECONNECT

## ◆ GetPacketHeaderSizeToRead()

virtual int abstract::GetPacketHeaderSizeToRead | ( |  | ) |
| pure virtual

Returns a pointer on an array with a determined size.

Returns
  A char array

## ◆ GetPacketLengthToRead()

virtual int abstract::GetPacketLengthToRead | ( | char * | pLenHeaderBuffer,
|  | int | pPacketType )
| pure virtual

Retrieve, in the pLenHeaderBuffer, the amount of data to read.

Parameters

  pLenHeaderBuffer |
  pPacketType |

Returns
  The amount of data to read

## ◆ GetPlatformVersion()

virtual uint16_t abstract::GetPlatformVersion | ( |  | ) |
| pure virtual

Gets the platform version /summary>

Returns
  a uint16_t containing the version number

## ◆ GetRuntimeHours()

virtual long abstract::GetRuntimeHours | ( |  | ) |
| pure virtual

Gets the sensor runtime hours.

Returns
  A long representing the sensor's runtime hours

## ◆ GetSettings()

BaseSettings * abstract::GetSettings | ( |  | ) |

Gets the communication settings.

Returns
  An encaspulation of communication settings

## ◆ GetStatus()

virtual int abstract::GetStatus | ( |  | ) |
| pure virtual

Returns the recorder's status (STOPPED, PLAYING, RECORDING)

Returns
  A integer expression

## ◆ GetTemperature()

virtual int abstract::GetTemperature | ( |  | ) |
| pure virtual

Gets the temperature.

Returns
  An integer representing the sensor's temperature

## ◆ GetTotalFrame()

long abstract::GetTotalFrame | ( |  | ) |

Returns the total frames contained in the record.

Returns

## ◆ GetTranslateCode()

string abstract::GetTranslateCode | ( |  | ) |

## ◆ GetVersion()

virtual SoftwareVersion abstract::GetVersion | ( |  | ) |
| pure virtual

Gets the sensor version data.

Returns
  An encapsulation representing the sensor version

## ◆ Initialize()

virtual CommunicationStatus abstract::Initialize | ( |  | ) |
| pure virtual

Pure virtual definition of a function that will initialise the extend class (connection, threads creation etc.)

## ◆ IsCommandAcknowledgment()

virtual bool abstract::IsCommandAcknowledgment | ( | string | pDataToVerify | ) |
| pure virtual

Pure virtual method that will help the caller to discriminate rawdata header from acknowledgment command data.

Parameters

  pDataToVerify | A string representing the stream result

Returns
  true if the stream result is an acknowledgment

## ◆ IsConnected()

bool abstract::IsConnected | ( |  | ) |

Indicates rather or not connect or disconnect method has been called.

Returns
  true if 'connect' has been called

## ◆ IsEndOfPacket()

virtual bool abstract::IsEndOfPacket | ( | string | pDataToVerify | ) |
| pure virtual

Pure virtual method that will help the caller to check if stream packet is the end of stream.

Parameters

  pDataToVerify | A string representing the setream packet

Returns
  true if the stream packet is the end of packet

## ◆ IsFirstPacket()

virtual bool abstract::IsFirstPacket | ( | string | pDataToVerify | ) |
| pure virtual

Pure virtual method that will help the caller to check if stream packet is the first packet of stream

Parameters

  pDataToVerify | A string representing the setream packet

Returns
  true if the stream packet is the first packet

## ◆ IsHeader()

virtual bool abstract::IsHeader | ( | string | pDataToVerify | ) |
| pure virtual

Pure virtual method that will thel the caller to check if the packet is a BEA Header.

Parameters

  pDataToVerify | A string representing the stream packet

Returns
  true if the stream packet is a Header

## ◆ Pause()

virtual void abstract::Pause | ( |  | ) |
| pure virtual

Pause the playback.

## ◆ Play()

virtual void abstract::Play | ( |  | ) |
| pure virtual

Plays a record from the file.

## ◆ Reconnect()

virtual CommunicationStatus abstract::Reconnect | ( |  | ) |
| protected pure virtual

## ◆ Record()

virtual void abstract::Record | ( |  | ) |
| pure virtual

Start recording data.

## ◆ RetrieveRawData()

virtual RawData abstract::RetrieveRawData | ( |  | ) |
| pure virtual

Pure virtual definition of a function that will help the caller to retrieve the data.

Returns

## ◆ SendCommand() [1/2]

virtual string abstract::SendCommand | ( | string | commandToSend | ) |
| pure virtual

Pure virtual method that will help the caller to send command on the media.

Parameters

  commandToSend | A string representing the command to be sent

Returns

## ◆ SendCommand() [2/2]

virtual string abstract::SendCommand | ( | string | commandToSend,
|  | int | specificTimeout )
| pure virtual

Pure virtual method that will help the caller to send command on the media with a specific timeout.

Parameters

  commandToSend | A string representing the command to be sent
  specificTimeout | A int representing the wished timeout in milliseconds

Returns

## ◆ SetCommunication()

void abstract::SetCommunication | ( | BaseCommunication * | pCom | ) |

Sets the communication layer.

Parameters

  pCom | The communication layer to be set

## ◆ SetCommunicationCallback() [1/2]

void abstract::SetCommunicationCallback | ( | ConnectionCheckerCallback |  | ) |

## ◆ SetCommunicationCallback() [2/2]

void abstract::SetCommunicationCallback | ( | void(* | ConnectionCheckerCallbackMethod )(CommunicationStatus *) | ) |

## ◆ SetCurrentFramePosition()

void abstract::SetCurrentFramePosition | ( | long | pCurrentFramePosition | ) |
| protected

Sets the current frame being read.

Parameters

  pCurrentFramePosition | The current frame position

## ◆ SetDataExtractor()

void abstract::SetDataExtractor | ( | BaseDataExtractor * | pDataExtractor | ) |

Sets the data extractor.

Parameters

  pDataExtractor | The data extractor to be set

## ◆ SetDataRecorder()

void abstract::SetDataRecorder | ( | BaseDataRecorder * | pDataRecorder | ) |

Sets the data recorder.

Parameters

  pDataRecorder | The data recorder layer to be set

## ◆ SetDeviceName()

virtual ConfigurationResult abstract::SetDeviceName | ( | string | pName | ) |
| pure virtual

Sets the sensor's name.

Returns
  A string representing the sensor's name

## ◆ SetFrameRate()

void abstract::SetFrameRate | ( | int | pFrameRate | ) |

Sets the framerate (thread safe)

Parameters

  pFrameRate | an integer representing the framerate

## ◆ SetSettings()

void abstract::SetSettings | ( | BaseSettings * | settings | ) |

Sets the communication settings.

Parameters

  settings | The communication settings to be set

## ◆ SetTotalFrame()

void abstract::SetTotalFrame | ( | long | pTotalFrame | ) |
| protected

Sets the total frame of the record.

Parameters

  pTotalFrame | The total frame

## ◆ SetTranslateCode()

void abstract::SetTranslateCode | ( | string | translateCode | ) |

## ◆ StartMonitoring()

void abstract::StartMonitoring | ( |  | ) |

Starts the monitoring process.

## ◆ Stop()

virtual void abstract::Stop | ( |  | ) |
| pure virtual

Stops either playing or recording.

## ◆ StopMonitoring()

void abstract::StopMonitoring | ( |  | ) |

Stops the monitoring process.

## ◆ WaitForRawData() [1/2]

virtual RawData abstract::WaitForRawData | ( |  | ) |
| pure virtual

Wait for a data comming from the player.

Returns
  The replayed data

## ◆ WaitForRawData() [2/2]

virtual RawData abstract::WaitForRawData | ( | int | waitTimeout,
|  | unsigned long * | semStatus )
| pure virtual

Pure virtual method that will help the caller to wait for RAW data comming from the media.

Parameters

  waitTimeout | The amount of miliseconds the process has to wait befor being released
  semStatus | The status of the semaphore (updated by reference)

Returns
  A pointer to RAW Data

## Member Data Documentation

## ◆ __version

SoftwareVersion abstract::__version
| protected

## ◆ _connected

std::atomic<bool> abstract::_connected
| protected

## ◆ _connStatus

volatile int abstract::_connStatus = 0
| protected

The mutex for the connection state value.

## ◆ _dataTimeout

int abstract::_dataTimeout
| protected

## ◆ _isConnected

std::atomic<bool> abstract::_isConnected
| protected

## ◆ _mutexConnectState

void* abstract::_mutexConnectState
| protected

The mutex for the monitoring flag.

## ◆ _mutexMonitoring

void* abstract::_mutexMonitoring
| protected

## ◆ _reconnecting

std::atomic<bool> abstract::_reconnecting
| protected

## ◆ CHECKSUM

string abstract::CHECKSUM = { 0x03 }
| protected

## ◆ cRA

string abstract::cRA = { 0x63, 0x52, 0x41 }
| protected

## ◆ cRN

string abstract::cRN = { 0x63, 0x52, 0x4E }
| protected

## ◆ cWA

string abstract::cWA = { 0x63, 0x57, 0x41 }
| protected

## ◆ cWN

string abstract::cWN = { 0x63, 0x57, 0x4E }
| protected

## ◆ FAILED_INITIALIZE

const int abstract::FAILED_INITIALIZE = 4
| static

## ◆ FAILED_START_RECORDING

const int abstract::FAILED_START_RECORDING = 3
| static

## ◆ GetCont

string abstract::GetCont = { 0x47 ,0x65 ,0x74 ,0x43, 0x6F, 0x6E, 0x74 }
| protected

## ◆ GetDHCP

string abstract::GetDHCP = { 0x47 ,0x65 ,0x74 ,0x44 ,0x48 ,0x43 ,0x50 }
| protected

## ◆ GetDir

string abstract::GetDir = { 0x47 ,0x65 ,0x74 ,0x44 ,0x69 ,0x72 }
| protected

## ◆ GetECode

string abstract::GetECode = { 0x47 ,0x65 ,0x74 ,0x45 ,0x43 ,0x6F, 0x64, 0x65 }
| protected

## ◆ GetELog

string abstract::GetELog = { 0x47 ,0x65 ,0x74 ,0x45, 0x4C, 0x6F, 0x67 }
| protected

## ◆ GetEthCfg

string abstract::GetEthCfg = { 0x47 ,0x65 ,0x74 ,0x45 ,0x74 ,0x68, 0x43, 0x66, 0x67 }
| protected

## ◆ GetFilter

string abstract::GetFilter = { 0x47 ,0x65 ,0x74 ,0x46 ,0x69 ,0x6C, 0x74, 0x65 , 0x72 }
| protected

## ◆ GetGW

string abstract::GetGW = { 0x47 ,0x65 ,0x74 ,0x47 ,0x57 }
| protected

## ◆ GetHours

string abstract::GetHours = { 0x47 ,0x65 ,0x74 ,0x48 ,0x6F ,0x75, 0x72, 0x73 }
| protected

## ◆ GetIP

string abstract::GetIP = { 0x47, 0x65, 0x74, 0x49, 0x50 }
| protected

## ◆ GetLamp

string abstract::GetLamp = { 0x47 ,0x65 ,0x74 ,0x4C, 0x61, 0x6D, 0x70 }
| protected

## ◆ GetLED

string abstract::GetLED = { 0x47 ,0x65 ,0x74 ,0x4C, 0x45, 0x44 }
| protected

## ◆ GetMask

string abstract::GetMask = { 0x47 ,0x65 ,0x74 ,0x4D ,0x61 ,0x73 ,0x6B }
| protected

## ◆ GetName

string abstract::GetName = { 0x47 ,0x65 ,0x74 ,0x4E ,0x61 ,0x6D, 0x65 }
| protected

## ◆ GetPLVerBin

string abstract::GetPLVerBin = { 0x47, 0x65, 0x74, 0x50, 0x4C, 0x56, 0x65, 0x72 }
| protected

## ◆ GetPort

string abstract::GetPort = { 0x47 ,0x65 ,0x74 ,0x50 ,0x6F ,0x72 ,0x74 }
| protected

## ◆ GetProto

string abstract::GetProto = { 0x47 ,0x65 ,0x74 ,0x50 ,0x72 ,0x6F ,0x74 ,0x6F }
| protected

## ◆ GetPType

string abstract::GetPType = { 0x47 ,0x65 ,0x74 ,0x50 ,0x54 ,0x79 ,0x70, 0x65 }
| protected

## ◆ GetRange

string abstract::GetRange = { 0x47 ,0x65 ,0x74 ,0x52, 0x61, 0x6E, 0x67, 0x65 }
| protected

## ◆ GetResol

string abstract::GetResol = { 0x47 ,0x65 ,0x74 ,0x52 ,0x65 ,0x73 ,0x6F, 0x6C }
| protected

## ◆ GetSkip

string abstract::GetSkip = { 0x47 ,0x65 ,0x74 ,0x53, 0x6B, 0x69, 0x70 }
| protected

## ◆ GetStat

string abstract::GetStat = { 0x47 ,0x65 ,0x74 ,0x53, 0x74, 0x61, 0x74 }
| protected

## ◆ GetTem

string abstract::GetTem = { 0x47 ,0x65 ,0x74 ,0x54, 0x65, 0x6D }
| protected

## ◆ GetVer

string abstract::GetVer = { 0x47 ,0x65 ,0x74 ,0x56, 0x65, 0x72 }
| protected

## ◆ GetWCalib

string abstract::GetWCalib = { 0x47 ,0x65 ,0x74, 0x57, 0x43, 0x61, 0x6C, 0x69, 0x62 }
| protected

## ◆ GetWinStat

string abstract::GetWinStat = { 0x47, 0x65, 0x74, 0x57, 0x69, 0x6E, 0x53, 0x74, 0x61, 0x74 }
| protected

## ◆ HEADER

string abstract::HEADER = { 0x02 , 0x02, (char)0xBE,(char)0xA0, 0x12, 0x34 }
| protected

## ◆ PAUSED

const int abstract::PAUSED = 5
| static

## ◆ PLAYING

const int abstract::PLAYING = 1
| static

## ◆ Reboot

string abstract::Reboot = { 0x52, 0x65, 0x62, 0x6F, 0x6F, 0x74 }
| protected

## ◆ RECORDING

const int abstract::RECORDING = 2
| static

## ◆ Reset

string abstract::Reset = { 0x52, 0x65, 0x73, 0x65, 0x74 }
| protected

## ◆ SendMDI

string abstract::SendMDI = { 0x53 ,0x65 ,0x6E ,0x64 ,0x4D ,0x44 ,0x49 }
| protected

## ◆ SetCont

string abstract::SetCont = { 0x53, 0x65, 0x74, 0x43, 0x6F, 0x6E, 0x74 }
| protected

## ◆ SetDHCP

string abstract::SetDHCP = { 0x53, 0x65, 0x74, 0x44, 0x48, 0x43, 0x50 }
| protected

## ◆ SetDir

string abstract::SetDir = { 0x53, 0x65, 0x74, 0x44, 0x69, 0x72 }
| protected

## ◆ SetEthCfg

string abstract::SetEthCfg = { 0x53 ,0x65 ,0x74 ,0x45 ,0x74 ,0x68, 0x43, 0x66, 0x67 }
| protected

## ◆ SetFilter

string abstract::SetFilter = { 0x53 ,0x65 ,0x74 ,0x46 ,0x69 ,0x6C, 0x74, 0x65 , 0x72 }
| protected

## ◆ SetGW

string abstract::SetGW = { 0x53, 0x65, 0x74, 0x47, 0x57 }
| protected

## ◆ SetIP

string abstract::SetIP = { 0x53, 0x65, 0x74, 0x49, 0x50 }
| protected

## ◆ SetLED

string abstract::SetLED = { 0x53, 0x65, 0x74, 0x4C, 0x45, 0x44 }
| protected

## ◆ SetMask

string abstract::SetMask = { 0x53, 0x65, 0x74, 0x4D, 0x61, 0x73, 0x6B }
| protected

## ◆ SetName

string abstract::SetName = { 0x53 ,0x65 ,0x74 ,0x4E ,0x61 ,0x6D, 0x65 }
| protected

## ◆ SetPort

string abstract::SetPort = { 0x53, 0x65, 0x74, 0x50, 0x6F, 0x72, 0x74 }
| protected

## ◆ SetProto

string abstract::SetProto = { 0x53, 0x65, 0x74, 0x50, 0x72, 0x6F, 0x74,0x6F }
| protected

## ◆ SetPType

string abstract::SetPType = { 0x53, 0x65, 0x74, 0x50, 0x54, 0x79, 0x70, 0x65 }
| protected

## ◆ SetRange

string abstract::SetRange = { 0x53, 0x65, 0x74, 0x52, 0x61, 0x6E, 0x67, 0x65 }
| protected

## ◆ SetResol

string abstract::SetResol = { 0x53, 0x65, 0x74, 0x52,0x65, 0x73, 0x6F, 0x6C }
| protected

## ◆ SetSkip

string abstract::SetSkip = { 0x53, 0x65, 0x74, 0x53, 0x6B, 0x69, 0x70 }
| protected

## ◆ SetWCalib

string abstract::SetWCalib = { 0x53 ,0x65 ,0x74, 0x57, 0x43, 0x61, 0x6C, 0x69, 0x62 }
| protected

## ◆ SPC

string abstract::SPC = { 0x20 }
| protected

## ◆ StopMDI

string abstract::StopMDI = { 0x53 ,0x74 ,0x6F ,0x70 ,0x4D ,0x44 ,0x49 }
| protected

## ◆ STOPPED

const int abstract::STOPPED = 0
| static

The documentation for this class was generated from the following files:

- BaseCommunication.h
- BaseDataRecorder.h
- BaseSensor.h
- BaseSettings.h
- TranscribableException.h
- BaseDataExtractor.h